version: '3'

networks:
  backend:

services:
  nginx:
    image: nginx:stable-alpine
    container_name: a-nginx
    ports:
      - "8000:80"
    volumes:
      - ./src:/var/www/html
      - ./nginx/default.conf:/etc/nginx/conf.d/default.conf
    depends_on:
      - php
      - mysql
    networks:
      - backend

  mysql:  
    image: mysql:8.0.29
    container_name: a-mysql
    restart: unless-stopped
    tty: true
    volumes:
      - ./mysql:/var/lib/mysql
    ports:
      - '3306:3306'
    environment:
      MYSQL_DATABASE: laravel
      MYSQL_USER: homestead
      MYSQL_PASSWORD: secret
      MYSQL_ROOT_PASSWORD: secret
      SERVICE_TAGS: dev
      SERVICE_NAME: mysql


    networks:
      - backend

  php:
    build:
      context: .
      dockerfile: Dockerfile
    container_name: a-php
    volumes:
      - ./src:/var/www/html
    ports:
      - '9000:9000'
    networks:
      - backend

  composer:
    image: composer:latest
    container_name: a-composer
    volumes:
      - ./src:/var/www/html
    working_dir: /var/www/html
    depends_on:
      - php
    networks:
      - backend
  npm:
    image: node:latest
    container_name: a-npm
    volumes:
      - ./src:/var/www/html
    working_dir: /var/www/html
    entrypoint: [ 'npm' ]

  artisan:
    build:
      context: .
      dockerfile: Dockerfile
    container_name: a-artisan
    volumes:
      - ./src:/var/www/html
    depends_on:
      - mysql
    working_dir: /var/www/html
    entrypoint: [ 'php','/var/www/html/artisan' ]
    networks:
      - backend
  phpmyadmin:
    container_name: a-phpmyadmin
    image: phpmyadmin/phpmyadmin
    restart: always
    ports:
      - 8081:80
    environment:
      PMA_ARBITRARY: 1
      MYSQL_ROOT_PASSWORD: secret
      PMA_HOST: mysql
      PMA_USER: homestead
      PMA_PASSWORD: secret
    depends_on:
      - mysql
    volumes:
      - my-db
    networks:
      - backend